#ifndef IMU_MEASURE_H
#define IMU_MEASURE_H

//#ifndef EIGEN_DONT_ALIGN_STATICALLY
//#define EIGEN_DONT_ALIGN_STATICALLY
//#endif

#include "base_measure.h"
namespace Localization {
namespace Ego {

class ImuMeasure : public BaseMeasure {
public:
    ImuMeasure() = delete;
    ImuMeasure(const ImuMeasure &) = delete;
    ImuMeasure & operator=(const ImuMeasure &) = delete;
    ImuMeasure(const MeasurementType &mType,const ImuInfo &imuInfo);
    void CheckValid();
    // ****** function ****** //
    bool Update(const State &state, State &nextState) override;
    bool UpdateStateIMU(const State &state, State &nextState, const Eigen::VectorXd &innov,
        const Eigen::MatrixXd &mH);
    Eigen::VectorXd MeasurementEquation(const State &state) const;
    void ObserveWithInstallAngle(const State &state, State &nextState, Eigen::VectorXd &innov,
                                             Eigen::MatrixXd &mH);
    void ObserveIMU(const State &state, State &nextState, Eigen::VectorXd &innov,
                                                Eigen::MatrixXd &mH);

    // data
    Eigen::Vector3d acc_ = Eigen::Vector3d::Zero();
    Eigen::Vector3d gyro_ = Eigen::Vector3d::Zero();
    Eigen::Vector3d gravity_ = Eigen::Vector3d(0.0, 0.0, -9.80665);
    // noise
    double imuAccNoiseVar_ = 0.1 * 0.1;
    double imuGyroNoiseVar_ = 0.01 * 0.01;

    static double latestUpdateTime_;

}; // class ImuMeasure

} // namespace Ego
} // namespace Localizaiton
#endif
